orte/mca/pls/bproc/pls_bproc.c File Reference.TH "orte/mca/pls/bproc/pls_bproc.c" 3 "7 Dec 2005" "Version 0.1.1" "OpenMPI" \" -*- nroff -*-
.ad l
.nh
.SH NAME
orte/mca/pls/bproc/pls_bproc.c \- Part of the bproc launcher. 
.SH SYNOPSIS
.br
.PP
\fC#include 'orte_config.h'\fP
.br
\fC#include <sys/types.h>\fP
.br
\fC#include <sys/stat.h>\fP
.br
\fC#include <unistd.h>\fP
.br
\fC#include <sys/errno.h>\fP
.br
\fC#include <signal.h>\fP
.br
\fC#include <fcntl.h>\fP
.br
\fC#include <string.h>\fP
.br
\fC#include 'opal/event/event.h'\fP
.br
\fC#include 'opal/mca/base/mca_base_param.h'\fP
.br
\fC#include 'opal/util/argv.h'\fP
.br
\fC#include 'opal/util/output.h'\fP
.br
\fC#include 'opal/util/opal_environ.h'\fP
.br
\fC#include 'opal/util/path.h'\fP
.br
\fC#include 'opal/util/show_help.h'\fP
.br
\fC#include 'orte/util/sys_info.h'\fP
.br
\fC#include 'orte/mca/errmgr/errmgr.h'\fP
.br
\fC#include 'orte/mca/iof/iof.h'\fP
.br
\fC#include 'orte/mca/ns/base/base.h'\fP
.br
\fC#include 'orte/mca/sds/base/base.h'\fP
.br
\fC#include 'orte/mca/oob/base/base.h'\fP
.br
\fC#include 'orte/mca/ras/base/base.h'\fP
.br
\fC#include 'orte/mca/rmgr/base/base.h'\fP
.br
\fC#include 'orte/mca/rmaps/base/base.h'\fP
.br
\fC#include 'orte/mca/rmaps/base/rmaps_base_map.h'\fP
.br
\fC#include 'orte/mca/rml/rml.h'\fP
.br
\fC#include 'orte/mca/soh/base/base.h'\fP
.br
\fC#include 'orte/runtime/orte_wait.h'\fP
.br
\fC#include 'orte/runtime/runtime.h'\fP
.br
\fC#include 'pls_bproc.h'\fP
.br

.SS "Functions"

.in +1c
.ti -1c
.RI "static int \fBorte_pls_bproc_node_array\fP (orte_rmaps_base_map_t *map, int **node_array, int *node_array_len)"
.br
.RI "\fIcreates an array that is indexed by the node number and each entry contains the number of processes that will be launched on that node. \fP"
.ti -1c
.RI "static int \fBorte_pls_bproc_node_list\fP (int *node_array, int node_array_len, int **node_list, int *num_nodes, int num_procs)"
.br
.RI "\fICreates a bproc nodelist from a node array. \fP"
.ti -1c
.RI "static int \fBorte_pls_bproc_setup_io\fP (\fBorte_jobid_t\fP jobid, struct bproc_io_t *io, int node_rank, int app_context)"
.br
.RI "\fISets up the bproc io structs for the specified rank on the nodes. \fP"
.ti -1c
.RI "static void \fBorte_pls_bproc_waitpid_cb\fP (pid_t wpid, int status, void *data)"
.br
.RI "\fICallback for orte_wait_cb. \fP"
.ti -1c
.RI "static void \fBorte_pls_bproc_waitpid_daemon_cb\fP (pid_t wpid, int status, void *data)"
.br
.RI "\fICallback for orte_wait_cb for the daemons. \fP"
.ti -1c
.RI "static void \fBorte_pls_bproc_setup_env\fP (char ***env, size_t *num_env)"
.br
.RI "\fISets up the passed environment for processes launched by the bproc launcher. \fP"
.ti -1c
.RI "static int \fBorte_pls_bproc_launch_daemons\fP (orte_cellid_t cellid, char ***envp, int **node_arrays, int *node_array_lens, int num_contexts, int num_procs, orte_vpid_t global_vpid_start, \fBorte_jobid_t\fP jobid)"
.br
.RI "\fILaunches the daemons. \fP"
.ti -1c
.RI "static int \fBorte_pls_bproc_launch_app\fP (orte_cellid_t cellid, \fBorte_jobid_t\fP jobid, orte_rmaps_base_map_t *map, int num_processes, orte_vpid_t vpid_start, orte_vpid_t global_vpid_start, int app_context, int *node_array, int node_array_len)"
.br
.RI "\fILaunches the application processes. \fP"
.ti -1c
.RI "int \fBorte_pls_bproc_launch\fP (\fBorte_jobid_t\fP jobid)"
.br
.RI "\fIThe main bproc launcher. \fP"
.ti -1c
.RI "int \fBorte_pls_bproc_terminate_job\fP (\fBorte_jobid_t\fP jobid)"
.br
.RI "\fITerminate all processes associated with this job - including daemons. \fP"
.ti -1c
.RI "int \fBorte_pls_bproc_terminate_proc\fP (const orte_process_name_t *proc_name)"
.br
.RI "\fITerminate a specific process. \fP"
.ti -1c
.RI "int \fBorte_pls_bproc_finalize\fP (void)"
.br
.RI "\fIModule cleanup. \fP"
.in -1c
.SS "Variables"

.in +1c
.ti -1c
.RI "char ** \fBenviron\fP"
.br
.RI "\fIOur current evironment. \fP"
.ti -1c
.RI "\fBorte_pls_base_module_t\fP \fBorte_pls_bproc_module\fP"
.br
.RI "\fIInitialization of the bproc module with all the needed function pointers. \fP"
.in -1c
.SH "Detailed Description"
.PP 
Part of the bproc launcher. 

See \fBpls_bproc.h\fP for an overview of how it works.
.SH "Function Documentation"
.PP 
.SS "int orte_pls_bproc_launch (\fBorte_jobid_t\fP jobid)"
.PP
The main bproc launcher. 
.PP
See \fBpls_bproc.h\fP for a high level overview of how the bproc launching works. Here we:
.IP "1." 4
Launch the deamons on the backend nodes.
.IP "2." 4
The daemons setup files for io forwarding then connect back to us to tells us they are ready for the actual apps.
.IP "3." 4
Launch the apps on the backend nodes
.PP
.PP
\fBParameters:\fP
.RS 4
\fIjobid\fP the jobid of the job to launch 
.RE
.PP
\fBReturn values:\fP
.RS 4
\fIORTE_SUCCESS\fP .br
\fIerror\fP .RE
.PP

.SS "static int orte_pls_bproc_launch_app (orte_cellid_t cellid, \fBorte_jobid_t\fP jobid, orte_rmaps_base_map_t * map, int num_processes, orte_vpid_t vpid_start, orte_vpid_t global_vpid_start, int app_context, int * node_array, int node_array_len)\fC [static]\fP"
.PP
Launches the application processes. 
.PP
\fBParameters:\fP
.RS 4
\fIcellid\fP the cellid of the job 
.br
\fIjobid\fP the jobid of the job 
.br
\fImap\fP a pointer to the mapping of this application 
.br
\fInum_processes\fP the number of processes in this job 
.br
\fIvpid_start\fP the starting vpid for this app context 
.br
\fIglobal_vpid_start\fP the starting vpid for the user's processes 
.br
\fIapp_context\fP the application context number 
.br
\fInode_array\fP the node array for this context 
.br
\fInode_array_len\fP the length of the node array 
.RE
.PP
\fBReturn values:\fP
.RS 4
\fIORTE_SUCCESS\fP .br
\fIerror\fP .RE
.PP

.SS "static int orte_pls_bproc_launch_daemons (orte_cellid_t cellid, char *** envp, int ** node_arrays, int * node_array_lens, int num_contexts, int num_procs, orte_vpid_t global_vpid_start, \fBorte_jobid_t\fP jobid)\fC [static]\fP"
.PP
Launches the daemons. 
.PP
\fBParameters:\fP
.RS 4
\fIcellid\fP the cellid of the job 
.br
\fIenvp\fP a pointer to the environment to use for the daemons 
.br
\fInode_arrays\fP an array that holds the node arrays for each app context 
.br
\fInode_array_lens\fP an array of lengths of the node arrays 
.br
\fInum_contexts\fP the number of application contexts 
.br
\fInum_procs\fP the numer of processes in the job 
.br
\fIglobal_vpid_start\fP the starting vpid for the user's processes 
.br
\fIjobid\fP the jobid for the user processes 
.RE
.PP
\fBReturn values:\fP
.RS 4
\fIORTE_SUCCESS\fP .br
\fIerror\fP .RE
.PP

.SS "static int orte_pls_bproc_node_array (orte_rmaps_base_map_t * map, int ** node_array, int * node_array_len)\fC [static]\fP"
.PP
creates an array that is indexed by the node number and each entry contains the number of processes that will be launched on that node. 
.PP
\fBParameters:\fP
.RS 4
\fImap\fP single context mapping 
.br
\fInode_array\fP a pointer to put the node array into 
.br
\fInode_array_len\fP returns the length of the array 
.RE
.PP
\fBReturn values:\fP
.RS 4
\fI>=0\fP the number of processes 
.br
\fI<0\fP orte err 
.RE
.PP

.SS "static int orte_pls_bproc_node_list (int * node_array, int node_array_len, int ** node_list, int * num_nodes, int num_procs)\fC [static]\fP"
.PP
Creates a bproc nodelist from a node array. 
.PP
\fBParameters:\fP
.RS 4
\fInode_array\fP an array of bproc nodes that contains the number of processes to be launched on each node 
.br
\fInode_array_len\fP the length of the node array 
.br
\fInode_list\fP a pointer that the bproc node list will be returned in 
.br
\fInum_nodes\fP a pointer to return the number of nodes in the node list 
.br
\fInum_procs\fP the number of processes that a node must have to be on the node list 
.RE
.PP

.SS "static void orte_pls_bproc_setup_env (char *** env, size_t * num_env)\fC [static]\fP"
.PP
Sets up the passed environment for processes launched by the bproc launcher. 
.PP
\fBParameters:\fP
.RS 4
\fIenv\fP a pointer to the environment to setup 
.br
\fInum_env\fP a pointer to where the size f the environment is stored 
.RE
.PP

.SS "static int orte_pls_bproc_setup_io (\fBorte_jobid_t\fP jobid, struct bproc_io_t * io, int node_rank, int app_context)\fC [static]\fP"
.PP
Sets up the bproc io structs for the specified rank on the nodes. 
.PP
\fBParameters:\fP
.RS 4
\fIjobid\fP .br
\fIio\fP A pointer to an array of 3 bproc_io_t structs 
.br
\fInode_rank\fP the rank on the node we are setting up the structs for 
.br
\fIapp_context\fP the application context number 
.RE
.PP
\fBReturn values:\fP
.RS 4
\fIORTE_SUCCESS\fP .br
\fIerror\fP .RE
.PP

.SS "static void orte_pls_bproc_waitpid_cb (pid_t wpid, int status, void * data)\fC [static]\fP"
.PP
Callback for orte_wait_cb. 
.PP
This function decrements the number of currently running processes, and when this hits 0 it kills all the daemons 
.PP
\fBParameters:\fP
.RS 4
\fIwpid\fP the process's pid 
.br
\fIstatus\fP tells why the process died 
.br
\fIdata\fP a pointer to the process's name 
.RE
.PP

.SS "static void orte_pls_bproc_waitpid_daemon_cb (pid_t wpid, int status, void * data)\fC [static]\fP"
.PP
Callback for orte_wait_cb for the daemons. 
.PP
If a daemon unexpectedly dies before we are done launching, we abort the job. 
.PP
\fBParameters:\fP
.RS 4
\fIwpid\fP the daemons's pid 
.br
\fIstatus\fP tells why the daemon died 
.br
\fIdata\fP a pointer to the node the daemon was on 
.RE
.PP

.SH "Variable Documentation"
.PP 
.SS "\fBorte_pls_base_module_t\fP \fBorte_pls_bproc_module\fP"
.PP
\fBInitial value:\fP
.PP
.nf
 {
    orte_pls_bproc_launch,
    orte_pls_bproc_terminate_job,
    orte_pls_bproc_terminate_proc,
    orte_pls_bproc_finalize
}
.fi
Initialization of the bproc module with all the needed function pointers. 
.PP
.SH "Author"
.PP 
Generated automatically by Doxygen for OpenMPI from the source code.
